//ai_oddSelector.jsx     2016.09.29 （z-） ver_c
//選択オブジェクトの任意の半分のパスだけ選択してくれるやつ

var doc = app.activeDocument;
var sel = doc.selection;
var ary = [], ary2 = [], x, y, obj, tgt, boundsAry = [[], [], [], []];

var win = new Window("dialog{text:'ai_oddSelector', \
TB:Button{text:'上'}, \
H:Group{orientation:'row', \
LB:Button{text:'左'}, \
RB:Button{text:'右'}\
},\
BB:Button{text:'下'}}");

win.TB.onClick = closeFunc;
win.H.LB.onClick = closeFunc;
win.H.RB.onClick = closeFunc;
win.BB.onClick = closeFunc;

win.show();

function closeFunc(){
    tgt = this.text;
    win.close();
    main();
    }

function main(){
coordinatesFunc (sel, ary); //aryにpathPointsのあるオブジェクトをよりわけ

//x = getCenter(boundsAry[0], boundsAry[2]);
//y = getCenter(boundsAry[1], boundsAry[3]);
x = (boundsAry[0].sort(sortFunc)[0] + boundsAry[2].sort(sortFunc)[boundsAry[2].length - 1]) / 2;
y = (boundsAry[3].sort(sortFunc)[0] + boundsAry[1].sort(sortFunc)[boundsAry[1].length - 1]) / 2;

for(var i = 0; i < ary.length; i++){
    //x = (ary[i].geometricBounds[0] + ary[i].geometricBounds[2]) / 2;
    //y = (ary[i].geometricBounds[1] + ary[i].geometricBounds[3]) / 2;
    obj = {};
    obj["左上"] = [];
    obj["左下"] = [];
    obj["右上"] = [];
    obj["右下"] = [];
    for(var j = 0; j < ary[i].pathPoints.length; j++){
        var anc = ary[i].pathPoints[j].anchor;
        if(anc[0] < x && anc[1] > y){
            obj["左上"].push(ary[i].pathPoints[j]);
            }
        if(anc[0] < x && anc[1] < y){
            obj["左下"].push(ary[i].pathPoints[j]);
            }
        if(anc[0] > x && anc[1] > y){
            obj["右上"].push(ary[i].pathPoints[j]);
            }
        if(anc[0] > x && anc[1] < y){
            obj["右下"].push(ary[i].pathPoints[j]);
            }
        }
    ary2.push(obj);
    }
doc.selection = null;

switch(tgt){
    case "上" : selectFunc(ary2, "左上", "右上"); break;
    case "左" : selectFunc(ary2, "左上", "左下"); break;
    case "右" : selectFunc(ary2, "右上", "右下"); break;
    case "下" : selectFunc(ary2, "左下", "右下");
    }

}

function coordinatesFunc (sel, ary) {
    for (var i = 0; i < sel.length; i++) {
        if(sel[i].hasOwnProperty ("pageItems")) {
            coordinatesFunc (sel[i].pageItems, ary);
            continue;
            }
        if(sel[i].hasOwnProperty ("pathPoints")) {
            ary.push(sel[i]);
            boundsFunc(sel[i]);
            }
        }
    }

function selectFunc(ary, x, y){
    for(var i = 0; i < ary.length; i++){
        for(var j = 0; j < ary[i][x].length; j++){
            ary[i][x][j].selected = PathPointSelection.ANCHORPOINT;
            }
        for(j = 0; j < ary[i][y].length; j++){
            ary[i][y][j].selected = PathPointSelection.ANCHORPOINT;
            }
        }
    }

function boundsFunc(obj){
    for(var i = 0; i < 4; i++){
        boundsAry[i].push(obj.geometricBounds[i]);
        }
    }

function getCenter(min, max){
    //return (Math.min(eval(min.join(","))) + Math.max(eval(max.join(",")))) / 2;
    //return (min.sort()[0] + max.sort()[max.length - 1]) / 2;
    //return (Math.min.apply(undefined, min) + Math.max.apply(undefined, max)) / 2;
    }

function sortFunc(a, b){
    return a - b;
    }